"""A decorator that allows us to share parameters from one function to another"""

# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/01_delegates.ipynb.

# %% auto 0
__all__ = ['delegates']

# %% ../nbs/01_delegates.ipynb 3
import inspect

# %% ../nbs/01_delegates.ipynb 4
def delegates(to=None, keep=False):
    "Decorator: replace `**kwargs` in signature with params from `to`"
    def _f(f):
        if to is None: to_f,from_f = f.__base__.__init__,f.__init__
        else:          to_f,from_f = to,f
        sig = inspect.signature(from_f)
        sigd = dict(sig.parameters)
        k = sigd.pop('kwargs')
        s2 = {k:v for k,v in inspect.signature(to_f).parameters.items()
              if 
                  # v.default != inspect.Parameter.empty and
                  k not in sigd}
        sigd.update(s2)
        if keep: sigd['kwargs'] = k
        from_f.__signature__ = sig.replace(parameters=sigd.values())
        return f
    return _f
